// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from bosch_locator_bridge:msg/ClientExpandMapOverwriteZoneInformation.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__TRAITS_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'polygon'
#include "geometry_msgs/msg/detail/point32__traits.hpp"

namespace bosch_locator_bridge
{

namespace msg
{

inline void to_flow_style_yaml(
  const ClientExpandMapOverwriteZoneInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: polygon
  {
    if (msg.polygon.size() == 0) {
      out << "polygon: []";
    } else {
      out << "polygon: [";
      size_t pending_items = msg.polygon.size();
      for (auto item : msg.polygon) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ClientExpandMapOverwriteZoneInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: polygon
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.polygon.size() == 0) {
      out << "polygon: []\n";
    } else {
      out << "polygon:\n";
      for (auto item : msg.polygon) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ClientExpandMapOverwriteZoneInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace bosch_locator_bridge

namespace rosidl_generator_traits
{

[[deprecated("use bosch_locator_bridge::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  bosch_locator_bridge::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use bosch_locator_bridge::msg::to_yaml() instead")]]
inline std::string to_yaml(const bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation & msg)
{
  return bosch_locator_bridge::msg::to_yaml(msg);
}

template<>
inline const char * data_type<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation>()
{
  return "bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation";
}

template<>
inline const char * name<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation>()
{
  return "bosch_locator_bridge/msg/ClientExpandMapOverwriteZoneInformation";
}

template<>
struct has_fixed_size<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__TRAITS_HPP_
