// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from bosch_locator_bridge:msg/ClientExpandMapVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_H_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'zones'
#include "bosch_locator_bridge/msg/detail/client_expand_map_overwrite_zone_information__struct.h"
// Member 'prior_map_poses'
#include "geometry_msgs/msg/detail/pose_array__struct.h"
// Member 'prior_map_pose_types'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/ClientExpandMapVisualization in the package bosch_locator_bridge.
typedef struct bosch_locator_bridge__msg__ClientExpandMapVisualization
{
  /// Copyright (c) 2023 - for information on the respective copyright owner
  /// see the NOTICE file and/or the repository https://github.com/boschglobal/locator_ros_bridge.
  ///
  /// Licensed under the Apache License, Version 2.0 (the "License");
  /// you may not use this file except in compliance with the License.
  /// You may obtain a copy of the License at
  ///
  ///     http://www.apache.org/licenses/LICENSE-2.0
  ///
  /// Unless required by applicable law or agreed to in writing, software
  /// distributed under the License is distributed on an "AS IS" BASIS,
  /// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  /// See the License for the specific language governing permissions and
  /// limitations under the License.
  /// The time at which the Localization Client received the ClientExpandMapVisualizationDatagram
  builtin_interfaces__msg__Time timestamp;
  /// A unique id for matching datagrams that were emitted at the same time but by different visualization interfaces
  uint64_t visualization_id;
  /// A set of OverwriteZones
  bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation__Sequence zones;
  /// The poses in the prior map
  geometry_msgs__msg__PoseArray prior_map_poses;
  /// The type of the poses in the prior map
  rosidl_runtime_c__int32__Sequence prior_map_pose_types;
} bosch_locator_bridge__msg__ClientExpandMapVisualization;

// Struct for a sequence of bosch_locator_bridge__msg__ClientExpandMapVisualization.
typedef struct bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence
{
  bosch_locator_bridge__msg__ClientExpandMapVisualization * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} bosch_locator_bridge__msg__ClientExpandMapVisualization__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_VISUALIZATION__STRUCT_H_
